'use strict';

var clone = require('./clone.js');
var infer = require('./package.js');
var blueb = require('bluebird');
var fs = blueb.promisifyAll(require('fs'));
var temp = blueb.promisifyAll(require('temp').track());
var publ = require('./publish.js');
var dflt = require('lodash.defaults');

var defaultConfig = {
	access: 'public'
};

module.exports = function (id) {
	var config = arguments[1] === undefined ? {} : arguments[1];
	return temp.mkdirAsync(id).then(function (dir) {
		return clone(id, dir).then(function (repo) {
			return infer(id, dir, repo).then(function (pack) {
				return fs.writeFileAsync('' + dir + '/package.json', JSON.stringify(pack), 'utf8').then(function () {
					return publ(dflt(defaultConfig, config), dir).then(function () {
						return pack;
					});
				});
			});
		});
	});
};
